#include <string>

#include <readline/history.h>

#include "gui-main.h"
#include "tty-main.h"

int
main (int argc, char **argv)
{
  int new_argc = 0;

  char **new_argv = new char* [argc + 1];

  new_argv[new_argc++] = argv[0];

  int tty_mode = false;

  for (int i = 1; i < argc; i++)
    {
      if (argv[i] == std::string ("--tty"))
        tty_mode = true;
      else
        new_argv[new_argc++] = argv[i];
    }

  int status = tty_mode
    ? tty_main (new_argc, new_argv)
    : gui_main (new_argc, new_argv);

  delete [] new_argv;

  return status;
}
