#include <iostream>
#include <string>

#include <cstdio>
#include <cstdlib>

#include <readline/readline.h>
#include <readline/history.h>

#include "gui-main.h"
#include "tty-main.h"

#include "parse.h"

int
tty_main (int argc, char **argv)
{
  std::cout
    << "Example Calculator.\n"
    << "Available operations: + - * / ^ ()\n"
    << "Semicolon terminates statement.\n"
    << "GNU Readline available for history editing.\n" << std::endl;

  parser_init ();

  for (;;)
    {
      char *tmp = readline (beg_of_stmt ? ">> " : "");

      if (! tmp)
        break;

      if (*tmp)
        {
          add_history (tmp);
          using_history ();
        }

      std::string line = tmp;

      free (tmp);

      int status = parse_and_execute (line);

      if (status < 0)
        break;

      if (have_result)
        {
          std::cout << "ans = " << result << std::endl;

          have_result = false;
        }
    }

  parser_fini ();

  return 0;
}
